/**
 * Copyright (c) 2010 apdevblog.com
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package com.apdevblog.examples.facebook 
{
	import flash.events.TextEvent;
	import fl.containers.ScrollPane;
	import fl.controls.ScrollBarDirection;
	import fl.controls.ScrollPolicy;
	import fl.controls.TileList;
	import fl.data.DataProvider;
	import fl.events.ListEvent;

	import com.apdevblog.examples.facebook.assets.Bg;
	import com.apdevblog.examples.facebook.assets.BtnFacebook;
	import com.apdevblog.examples.facebook.assets.Logo;
	import com.apdevblog.utils.Draw;
	import com.facebook.Facebook;
	import com.facebook.commands.photos.GetAlbums;
	import com.facebook.commands.photos.GetPhotos;
	import com.facebook.commands.users.GetInfo;
	import com.facebook.data.photos.AlbumData;
	import com.facebook.data.photos.GetAlbumsData;
	import com.facebook.data.photos.GetPhotosData;
	import com.facebook.data.photos.PhotoData;
	import com.facebook.data.users.GetInfoData;
	import com.facebook.events.FacebookEvent;
	import com.facebook.net.FacebookCall;
	import com.facebook.session.WebSession;
	import com.facebook.utils.FacebookConnectUtil;

	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.external.ExternalInterface;
	import flash.net.SharedObject;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	/**
     * Demo image-viewer-app using the Facebook Connect API.
     * 
     * @playerversion Flash 10
     * @langversion 3.0
     *
     * @package    com.apdevblog.examples.facebook 
     * @author     Philipp Kyeck / philipp[at]apdevblog.com
     * @copyright  2010 apdevblog.com
     * @version    SVN: $Id$
     */
	[SWF(backgroundColor='#000000', width='500', height='400', frameRate='30')]
	public class FacebookConnectTest extends MovieClip 
	{
		public static const API_KEY:String = "22f5907a6979281d9a10684ee9a74320";
		public static const SO_NAME:String = "apdevblog.com/fbconnect";
		//
		private static const OVERVIEW:String = "OVERVIEW";
		private static const ALBUM_DETAIL:String = "ALBUM_DETAIL";
		private static const PHOTO_DETAIL:String = "PHOTO_DETAIL";
		//
		private var _connect:FacebookConnectUtil;
		private var _facebook:Facebook;
		//
		private var _debugLabel:TextField;
		private var _loginBtn:Sprite;
		private var _session:Object;
		//
		private var _list:TileList;
		private var _state:String;
		private var _albums:Array;
		private var _albumCovers:Array;
		private var _detailView:ScrollPane;
		private var _bgImage:Bg;
		private var _logo:Logo;
		private var _loginTxt:TextField;
		private var _closeDetailBtn:Sprite;
		private var _listTitle:TextField;
		private var _line:Shape;
		private var _selectedAlbum:AlbumData;
		private var _linkTxt:TextField;
		private var _debugView:Sprite;

		/**
		 * Constructor.
		 */
		public function FacebookConnectTest() 
		{
			log("FacebookConnectTest()");
			
			_init();
		}
		
		/**
		 * init the whole demo ...
		 */
		private function _init():void 
		{
			_albums = [];
			_albumCovers = [];
			
			_state = FacebookConnectTest.OVERVIEW;
			
			// draw logo + bg
			_drawStatics();
			
			//
			addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			
			// check if external interface is available
			if(ExternalInterface.available)
			{
				log("externalInterface is available");
				
				try
				{
					ExternalInterface.addCallback("onLogin", onLogin);
					ExternalInterface.addCallback("onLogout", onLogoutCallback);
				}
				catch(err:Error)
				{
					log("Error: " + err.message);
				}
				
				// create facebook instances
				_connect = new FacebookConnectUtil(loaderInfo);
				_facebook = new Facebook();
				
				// draw user interface
				_draw();
				
				// check SO for old session
				var my_so:SharedObject = SharedObject.getLocal(FacebookConnectTest.SO_NAME);
				
				if(my_so.data.session != null)
				{
					_session = my_so.data.session;
					
					//Start a WebSession with the ss and session key passed in from Javascript
					var webSession:WebSession = new WebSession(FacebookConnectTest.API_KEY, _session.secret, _session.session_key);				
					_facebook.startSession(webSession);
					
					webSession.addEventListener(FacebookEvent.CONNECT, onSessionConnect);
					webSession.addEventListener(FacebookEvent.ERROR, onSessionError);
					webSession.verifySession();
				}
			}
		}
		
		/**
		 * draw btns and ui elements on stage.
		 */
		private function _draw():void 
		{
			// login btn + txt
			_loginBtn = new BtnFacebook();
			
			_loginBtn.x = 490 - _loginBtn.width;
			_loginBtn.y = 30;
			
			_loginBtn.buttonMode = true;
			_loginBtn.addEventListener(MouseEvent.CLICK, onMouseClick, false, 0, true);
			
			addChild(_loginBtn);
			
			_loginTxt = new TextField();
			_loginTxt.visible = false;
			_loginTxt.mouseEnabled = true;
			_loginTxt.addEventListener(TextEvent.LINK, onClickTextLink, false, 0, true);
			
			_loginTxt.x = _loginBtn.x;
			_loginTxt.y = _loginBtn.y;
			
			_loginTxt.width = _loginBtn.width;
			_loginTxt.height = _loginBtn.height;
			
			// TF
			var tf:TextFormat = new TextFormat();
			tf.font = "_sans";
			tf.color = 0xFFFFFF;
			tf.align = TextFormatAlign.RIGHT;
			_loginTxt.defaultTextFormat = tf;
			//
			
			addChild(_loginTxt);
			//
			
			_listTitle = new TextField();
			_listTitle.visible = false;
			_listTitle.selectable = false;
			_listTitle.mouseEnabled = false;
			
			_listTitle.x = 8;
			_listTitle.y = 66;
			
			_listTitle.width = 480;
			_listTitle.height = 24;
			
			// TF
			tf = new TextFormat();
			tf.font = "_sans";
			tf.color = 0x66FF00;
			tf.size = 18;
			tf.bold = true;
			_listTitle.defaultTextFormat = tf;
			//
			
			addChild(_listTitle);
			
			//
			_list = new TileList();
			_list.direction = ScrollBarDirection.VERTICAL;
			_list.columnWidth = 130;
			_list.rowHeight = 130;
			_list.setSize(stage.stageWidth - 20, stage.stageHeight - 80);
			
			_list.x = 10;
			_list.y = 74;
			
			_list.addEventListener(ListEvent.ITEM_CLICK, onListItemClicked);
			
			addChild(_list);
			
			// detailview + close btn
			_detailView = new ScrollPane();
			_detailView.visible = false;
			_detailView.scrollDrag = true;
			_detailView.horizontalScrollPolicy = ScrollPolicy.OFF;
			_detailView.verticalScrollPolicy = ScrollPolicy.OFF;
			
			_detailView.x = 10;
			_detailView.y = 94;

			_detailView.setSize(stage.stageWidth - 20, stage.stageHeight - 104);
			
			_detailView.addEventListener(Event.COMPLETE, onDetailLoaded, false, 0, true);
			
			addChild(_detailView);
			
			//
			_closeDetailBtn = new Sprite();
			_closeDetailBtn.visible = false;
			_closeDetailBtn.buttonMode = true;
			_closeDetailBtn.mouseChildren = false;
			
			
			//
			var xTxt:TextField = new TextField();
			xTxt.width = 18;
			xTxt.height = 40;
			
			// TF
			tf = new TextFormat();
			tf.font = "_sans";
			tf.size = 22;
			tf.color = 0x66FF00;
			tf.bold = true;
			xTxt.defaultTextFormat = tf;
			//
			
			xTxt.selectable = false;
			xTxt.text = "x";
			
			_closeDetailBtn.addChild(xTxt);

			_closeDetailBtn.x = 490 - _closeDetailBtn.width;
			_closeDetailBtn.y = 62;
			
			_closeDetailBtn.addEventListener(MouseEvent.CLICK, onClickCloseDetailView, false, 0, true);
			
			addChild(_closeDetailBtn);
			//
			
			
			// link txt
			_linkTxt = new TextField();
			_linkTxt.visible = false;
			
			_linkTxt.x = 8;
			_linkTxt.y = stage.stageHeight - 10 - _linkTxt.height;
			
			_linkTxt.width = 500;
			_linkTxt.height = 20;
			
			// TF
			tf = new TextFormat();
			tf.font = "_sans";
			tf.size = 14;
			tf.color = 0x66FF00;
			_linkTxt.defaultTextFormat = tf;
			//
			
			_linkTxt.selectable = false;
			addChild(_linkTxt);
		}
		
		/**
		 * draw static ui elements on stage.
		 */
		private function _drawStatics():void 
		{
			// add BG image
			_bgImage = new Bg();
			_bgImage.x = -167;
			_bgImage.y = -139;
			addChildAt(_bgImage, 0);
			
			_logo = new Logo();
			_logo.x = 10;
			_logo.y = 10;
			addChild(_logo);
			
			_line = Draw.rect(480, 1, 0xFFFFFF);
			_line.x = 10;
			_line.y = 60;
			addChild(_line);
		}
		
		/**
		 * log user out.
		 */
		private function _logout():void 
		{
			//_loginBtn.visible = true;
			_loginTxt.visible = false;
			
			_closeDetailBtn.visible = false;
			_linkTxt.visible = false;
			_listTitle.visible = false;
			
			_albums = [];
			_albumCovers = [];
			
			_state = FacebookConnectTest.OVERVIEW;
			
			_session = null;
			var my_so:SharedObject = SharedObject.getLocal(FacebookConnectTest.SO_NAME);
			my_so.data.session = null;
			
			var dp:DataProvider = new DataProvider([]);
			_list.dataProvider = dp;
			
			_detailView.source = null;

			ExternalInterface.call("fbLogout");			
		}
		
		
		
		/**
		 * close the currently open detailview.
		 */
		private function _closeDetailView():void 
		{
			if(_state == FacebookConnectTest.ALBUM_DETAIL)
			{
				var dp:DataProvider = new DataProvider(_albumCovers);
				_list.dataProvider = dp;
				
				_closeDetailBtn.visible = false;
				_list.y = 74;
				_listTitle.visible = false;
				_listTitle.text = "";
				
				_selectedAlbum = null;
				
				_state = FacebookConnectTest.OVERVIEW;
			}
			else if(_state == FacebookConnectTest.PHOTO_DETAIL)
			{
				_detailView.visible = false;
				//_closeDetailBtn.visible = false;
				
				_list.clearSelection();
				_list.visible = true;
				
				if(_selectedAlbum != null)
				{
					_listTitle.text = _selectedAlbum.name;
				}
				else
				{
					_listTitle.text = "";					
				}
				
				_linkTxt.visible = false;
				_linkTxt.text = "";
				
				_detailView.source = null;
				_detailView.refreshPane();
				
				_state = FacebookConnectTest.ALBUM_DETAIL;
			}			
		}
		
		/**
		 * helper method returning the album
		 */
		private function _getAlbumById(aid:String):AlbumData
		{
			if(aid == null)
			{
				return null;
			}
			
			var album:AlbumData;
			
			for(var i:int=0;i<_albums.length;i++)
			{
				album = _albums[i] as AlbumData;
				if(album != null && album.aid == aid)
				{
					return album;
				}
			}
			
			return null;
		}

		
		
		private function _loadAlbumPhotos(aid:String):void 
		{
			log("_loadAlbumPhotos("+aid+")");
			
			_state = FacebookConnectTest.ALBUM_DETAIL;
			
			var call:FacebookCall = _facebook.post(new GetPhotos('', aid));
			call.addEventListener(FacebookEvent.COMPLETE, handleGetPhotosResponse2);
		}

		
		
		
		
		
		// *********************************************************************
		// event handler
		// *********************************************************************
		
		/**
		 * event handler for ADDED_TO_STAGE event.
		 */
		private function onAddedToStage(event:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			stage.addEventListener(Event.RESIZE, onStageResize);
			onStageResize();
			
			// keyboard support
			stage.addEventListener(KeyboardEvent.KEY_DOWN, onKeyDown);
		}
		
		/**
		 * event handler for close clicks.
		 */
		private function onClickCloseDetailView(event:MouseEvent):void 
		{
			_closeDetailView();
		}
		
		/**
		 * event handler for links in textfield
		 */
		private function onClickTextLink(event:TextEvent):void 
		{
			log("logout ...");
			_logout();
		}

		private function onDetailLoaded(event:Event):void 
		{
			//_detailView.content.addEventListener(MouseEvent.MOUSE_OVER, onMouseOverDetailView, false, 0, true);
			//_detailView.content.addEventListener(MouseEvent.MOUSE_OUT, onMouseOutDetailView, false, 0, true);
			
			//log("onDetailLoaded() >>> " + _detailView.content.width + "x" + _detailView.content.height);
		}
		
		/**
		 * event handler for keyboard events
		 */
		private function onKeyDown(event:KeyboardEvent):void 
		{
			if(event.ctrlKey && event.charCode == 4)
			{
				// toggle debug view
				_debugView.visible = !_debugView.visible;
				setChildIndex(_debugView, numChildren-1);
			}
		}
		
		/**
		 * event handler for clicking tile in tilelist.
		 */
		private function onListItemClicked(event:ListEvent):void 
		{
			log("onListItemClicked() >>> " + event.item.value);
			
			var coverDP:DataProvider;
			var aid:String = event.item.value;
			_selectedAlbum = _getAlbumById(aid);
			
			if(_state == FacebookConnectTest.OVERVIEW)
			{
				coverDP = new DataProvider([]);
				_list.dataProvider = coverDP;
				
				_list.y = 94;
				_listTitle.visible = true;
				
				if(_selectedAlbum != null)
				{
					_listTitle.text = _selectedAlbum.name;
				}
				else
				{
					_listTitle.text = "AlbumId: " + aid;
				}
				
				_closeDetailBtn.visible = true;
				
				_loadAlbumPhotos(aid);
			}
			else if(_state == FacebookConnectTest.ALBUM_DETAIL)
			{
				_detailView.visible = true;
				_list.visible = false;
				_closeDetailBtn.visible = true;
				
				if(_selectedAlbum != null)
				{
					_listTitle.text = _selectedAlbum.name + " / " + event.item.label;
				}
				
				_detailView.source = event.item.origin;
				
				_linkTxt.visible = true;
				_linkTxt.text = "Link: " + event.item.link;
				
				_state = FacebookConnectTest.PHOTO_DETAIL;
			}
		}
		
		/**
		 * event handler called when user clicks facebook connect button.
		 */
		private function onMouseClick(event:MouseEvent):void 
		{
			log("onMouseClick()");
			
			ExternalInterface.call("fbLogin", FacebookConnectTest.API_KEY);
		}
		
		/**
		 * 
		 */
		private function onSessionConnect(event:FacebookEvent):void 
		{
			log("onSessionConnect()");
			
			var call:FacebookCall = _facebook.post(new GetInfo([_session.uid], ['first_name', 'last_name']));
			call.addEventListener(FacebookEvent.COMPLETE, handleGetInfoResponse);
			
			_loginBtn.visible = false;
			_loginTxt.visible = true;
		}
		
		/**
		 * 
		 */
		private function onSessionError(event:FacebookEvent):void 
		{
			log("onSessionError() >>> " + event.error);
			
			var my_so:SharedObject = SharedObject.getLocal(FacebookConnectTest.SO_NAME);
			my_so.data.session = null;
		}
		
		/**
		 * event handler for stage's RESIZE events.
		 */
		private function onStageResize(event:Event=null):void 
		{
			if(_list != null)
			{
				_list.setSize(stage.stageWidth - 20, stage.stageHeight - 80);
			}

			if(_detailView != null)
			{
				_detailView.setSize(stage.stageWidth - 20, stage.stageHeight - 104);
			}

			if(_linkTxt != null)
			{
				_linkTxt.y = stage.stageHeight - 10 - _linkTxt.height;
			}
			
			if(_line != null)
			{
				_line.width = stage.stageWidth - 20;
				_closeDetailBtn.x = stage.stageWidth - 10 - _closeDetailBtn.width;
			}
			
			if(_loginBtn != null)
			{
				_loginBtn.x = stage.stageWidth - 10 - _loginBtn.width;
				_loginTxt.x = _loginBtn.x;
			}
		}
		
		// *********************************************************************
		// methods processing the API results
		// *********************************************************************
		
		private function handleGetAlbumsResponse(event:FacebookEvent):void 
		{
			var albumsResponseData:GetAlbumsData = event.data as GetAlbumsData;
			
			if(albumsResponseData != null)
			{
				var tempCovers:Array = [];
				
				for(var i:int = 0; i < albumsResponseData.albumCollection.length; i++)
				{
					var album:AlbumData = albumsResponseData.albumCollection.getItemAt(i) as AlbumData;
					
					if(album != null)
					{
						log(i + " :: " + album);
						_albums.push(album);
						tempCovers.push(album.cover_pid);
					}
				}
				
				
				var call:FacebookCall = _facebook.post(new GetPhotos('', '', tempCovers));
				call.addEventListener(FacebookEvent.COMPLETE, handleGetPhotosResponse);
			}
		}
		
		private function handleGetInfoResponse(event:FacebookEvent):void 
		{
			log("handleGetInfoResponse() >>> " + event.data);
			
			var infoData:GetInfoData = event.data as GetInfoData;
			if(infoData != null)
			{
				log("infoData.userCollection: " + infoData.userCollection);
				
				if(infoData.userCollection == null || infoData.userCollection.getItemAt(0) == null)
				{
					return;
				}
				
				var firstName:String = infoData.userCollection.getItemAt(0).first_name;
				var lastName:String = infoData.userCollection.getItemAt(0).last_name;
				
				_loginTxt.htmlText = "Hello " + firstName + " " + lastName + "! <a href='event:logout'>Logout</a>";
				log("Hello " + firstName + " " + lastName);
				
				// get albums
				var call:FacebookCall = _facebook.post(new GetAlbums(_session.uid));
				call.addEventListener(FacebookEvent.COMPLETE, handleGetAlbumsResponse);
			}
		}
		
		private function handleGetPhotosResponse(event:FacebookEvent):void 
		{
			log("handleGetPhotosResponse()");
			
			var photosResponseData:GetPhotosData = event.data as GetPhotosData;
			
			if(photosResponseData != null)
			{
				for(var i:int = 0; i < photosResponseData.photoCollection.length; i++)
				{
					var photo:PhotoData = photosResponseData.photoCollection.getItemAt(i) as PhotoData;
					
					
					if(photo != null)
					{
						var album:AlbumData = _getAlbumById(photo.aid);
						var label:String = (album != null) ? album.name : "";
						
						var obj:Object = {};
						
						obj.label = label;
						obj.value = photo.aid;
						obj.source = photo.src;
						obj.origin = photo.src_big;
						
						_albumCovers.push(obj);
					}
				}
				
				var coverDP:DataProvider = new DataProvider(_albumCovers);
				_list.dataProvider = coverDP;
			}
		}
		
		private function handleGetPhotosResponse2(event:FacebookEvent):void 
		{
			log("handleGetPhotosResponse2()");
			
			var photosResponseData:GetPhotosData = event.data as GetPhotosData;
			
			if(photosResponseData != null)
			{
				var photos:Array = [];
				
				for(var i:int = 0; i < photosResponseData.photoCollection.length; i++)
				{
					var photo:PhotoData = photosResponseData.photoCollection.getItemAt(i) as PhotoData;
					
					if(photo != null)
					{
						log("link: " + photo.link);
						
						var obj:Object = {};
						
						obj.label = photo.caption;
						obj.value = photo.aid;
						obj.source = photo.src;
						obj.origin = photo.src_big;
						obj.link = photo.link;
						
						photos.push(obj);
					}
				}
				
				var coverDP:DataProvider = new DataProvider(photos);
				_list.dataProvider = coverDP;
			}
		}
		
		// *********************************************************************
		// Javascript callbacks
		// *********************************************************************
		
		/**
		 * JS callback - called when user logged into facebook account.
		 */
		private function onLogin(session:Object):void
		{
			log("onLogin() >>> " + session);
			
			if(session == null)
			{
				log("user not logged in");
				return;
			}
			
			_session = session;
			
			// sa ve session data in shared object for later use ...
			var my_so:SharedObject = SharedObject.getLocal(FacebookConnectTest.SO_NAME);
			my_so.data.session = session;
			
			log("uid: " + session.uid);
			
			//Start a WebSession with the ss and session key passed in from Javascript
			var webSession:WebSession = new WebSession(FacebookConnectTest.API_KEY, session.secret, session.session_key);				
			_facebook.startSession(webSession);
			
			webSession.addEventListener(FacebookEvent.CONNECT, onSessionConnect);
			webSession.addEventListener(FacebookEvent.ERROR, onSessionError);
			webSession.verifySession();
		}
		
		/**
		 * JS callback - called when user is logged out.
		 */
		private function onLogoutCallback():void
		{
			log("onLogoutCallback() ...");
			_loginBtn.visible = true;
		}
		
		// *********************************************************************
		// misc helper methods
		// *********************************************************************
		
		/**
		 * logging method.
		 */
		private function log(msg:String):void
		{
			//return;
			
			if(_debugLabel == null)
			{
				_debugView = new Sprite();
				_debugView.visible = false;
				_debugView.x = 10;
				_debugView.y = 70;
				
				var blackBg:Shape = Draw.rect(300, 400, 0x000000);
				_debugView.addChild(blackBg);
				
				_debugLabel = new TextField();
				
				// TF
				var tf:TextFormat = new TextFormat();
				tf.font = "_typewriter";
				tf.color = 0x66ff00;
				
				_debugLabel.defaultTextFormat = tf;
				//
				
				_debugLabel.width = 300;
				_debugLabel.height = 400;
				
				_debugLabel.wordWrap = true;
				_debugLabel.multiline = true;
				_debugLabel.selectable = true;
				
				_debugView.addChild(_debugLabel);
				
				addChild(_debugView);
			}
			
			_debugLabel.appendText(msg + "\n");
			_debugLabel.scrollV = _debugLabel.maxScrollV;
		}
		
	}
}
